import sys

from PySide.QtCore import *
from PySide.QtGui  import *
from PySide.QtDeclarative import *

from mymail.search import SearchModel
from mymail.thread import ThreadModel

from mymail.notmuch_cli import Search

default_query = "tag:inbox AND tag:unread AND NOT tag:killed"

def exit():
    sys.exit(0)

if __name__ == "__main__":
    app = QApplication(sys.argv)
    
    if len(sys.argv) > 1:
        query = " ".join(sys.argv[1:]).decode("UTF-8")
    else:
        query = default_query
    
    search = SearchModel()
    # search.search(query)
    nmsearch = Search(query)
    nmsearch.thread.connect(search.add)
    nmsearch.start()
    
    thread = ThreadModel()
    
    view = QDeclarativeView()
    view.setWindowTitle("My Mail")
    view.setResizeMode(QDeclarativeView.SizeRootObjectToView)
    
    context = view.rootContext()
    context.setContextProperty('current_query', query)
    context.setContextProperty('search', search)
    context.setContextProperty('thread', thread)
    
    view.setSource("my-mail.qml")
    view.show()
    
    sys.exit(app.exec_())

